diff --git a/configure.ac b/configure.ac
index ed213a9..2f552bd 100644
--- a/configure.ac
+++ b/configure.ac
@@ -22,15 +22,24 @@ AC_CONFIG_AUX_DIR([build-aux])
 AC_CONFIG_MACRO_DIR([m4])
 AC_CONFIG_HEADERS(config.h)
 AM_INIT_AUTOMAKE([1.10 -Wall -Werror -Wno-override])
-AM_SILENT_RULES([yes])
 
 # Library code modified:                              REVISION++
 # Interfaces changed/added/removed:   CURRENT++       REVISION=0
 # Interfaces added:                             AGE++
 # Interfaces removed:                           AGE=0
-AC_SUBST(LT_CURRENT, 8)
-AC_SUBST(LT_REVISION, 2)
-AC_SUBST(LT_AGE, 2)
+#
+# The following are the original values from libtasn1-3.5:
+#
+#     AC_SUBST(LT_CURRENT, 8)
+#     AC_SUBST(LT_REVISION, 2)
+#     AC_SUBST(LT_AGE, 2)
+#
+# Since this patched package is libtasn1-3.5 wrapped to expose the same
+# API/ABI as libtasn1-1.5, we change the LT_* values to be the same
+# as they were in libtasn1-1.5.
+AC_SUBST(LT_CURRENT, 3)
+AC_SUBST(LT_REVISION, 16)
+AC_SUBST(LT_AGE, 0)
 
 AC_PROG_CC
 gl_EARLY
@@ -40,14 +49,13 @@ AC_PROG_YACC
 dnl Checks for programs.
 AM_MISSING_PROG(HELP2MAN, help2man, $missing_dir)
 AC_LIBTOOL_WIN32_DLL
-AM_PROG_AR
 AM_PROG_LIBTOOL
 GTK_DOC_CHECK(1.2)
 
 AC_CHECK_SIZEOF(unsigned long int, 4)
 AC_CHECK_SIZEOF(unsigned int, 4)
 
-sj_UPDATE_HEADER_VERSION([$srcdir/lib/libtasn1.h])
+sj_UPDATE_HEADER_VERSION([$srcdir/lib/libtasn1-internal.h])
 
 # For gnulib compatibility modules.
 gl_INIT
diff --git a/doc/gdoc b/doc/gdoc
index e3db762..2eb0dac 100755
--- a/doc/gdoc
+++ b/doc/gdoc
@@ -794,6 +794,7 @@ sub dump_function {
 	$prototype =~ m/^(\w+\s+\w+\s*\*)\s*([a-zA-Z0-9_~:]+)\s*\(([^\)]*)\)/)  {
 	$return_type = $1;
 	$function_name = $2;
+	$function_name =~ s/^asn1_internal/asn1/;
 	$args = $3;
 
 #	print STDERR "ARGS = '$args'\n";
diff --git a/examples/CertificateExample.c b/examples/CertificateExample.c
index a62ea79..32bc611 100644
--- a/examples/CertificateExample.c
+++ b/examples/CertificateExample.c
@@ -27,7 +27,7 @@
 #include <stdio.h>
 #include <string.h>
 #include <stdlib.h>
-#include "libtasn1.h"
+#include "libtasn1-internal.h"
 
 
 static char *
@@ -89,7 +89,7 @@ get_Name_type (ASN1_TYPE cert_def, ASN1_TYPE cert, const char *root,
       my_ltostr (k, counter);
       strcat (name, counter);
       len = sizeof (str) - 1;
-      result = asn1_read_value (cert, name, str, &len);
+      result = asn1_internal_read_value (cert, name, str, &len);
       if (result == ASN1_ELEMENT_NOT_FOUND)
 	break;
       k2 = 1;
@@ -100,90 +100,90 @@ get_Name_type (ASN1_TYPE cert_def, ASN1_TYPE cert, const char *root,
 	  my_ltostr (k2, counter);
 	  strcat (name2, counter);
 	  len = sizeof (str) - 1;
-	  result = asn1_read_value (cert, name2, str, &len);
+	  result = asn1_internal_read_value (cert, name2, str, &len);
 	  if (result == ASN1_ELEMENT_NOT_FOUND)
 	    break;
 	  strcpy (name3, name2);
 	  strcat (name3, ".type");
 	  len = sizeof (str) - 1;
-	  result = asn1_read_value (cert, name3, str, &len);
+	  result = asn1_internal_read_value (cert, name3, str, &len);
 	  strcpy (name3, name2);
 	  strcat (name3, ".value");
 	  if (result == ASN1_SUCCESS)
 	    {
 	      len = sizeof (str2) - 1;
 	      result =
-		asn1_read_value (cert_def,
+		asn1_internal_read_value (cert_def,
 				 "PKIX1Implicit88.id-at-countryName", str2,
 				 &len);
 	      if (!strcmp (str, str2))
 		{
-		  asn1_create_element (cert_def,
-				       "PKIX1Implicit88.X520OrganizationName",
-				       &value);
+		  asn1_internal_create_element (cert_def,
+						"PKIX1Implicit88.X520OrganizationName",
+						&value);
 		  len = sizeof (str) - 1;
-		  asn1_read_value (cert, name3, str, &len);
-		  asn1_der_decoding (&value, str, len, errorDescription);
+		  asn1_internal_read_value (cert, name3, str, &len);
+		  asn1_internal_der_decoding (&value, str, len, errorDescription);
 		  len = sizeof (str) - 1;
-		  asn1_read_value (value, "", str, &len);	/* CHOICE */
+		  asn1_internal_read_value (value, "", str, &len);	/* CHOICE */
 		  strcpy (name3, str);
 		  len = sizeof (str) - 1;
-		  asn1_read_value (value, name3, str, &len);
+		  asn1_internal_read_value (value, name3, str, &len);
 		  str[len] = 0;
 		  strcat (answer, " C=");
 		  strcat (answer, str);
-		  asn1_delete_structure (&value);
+		  asn1_internal_delete_structure (&value);
 		}
 	      else
 		{
 		  len = sizeof (str2) - 1;
 		  result =
-		    asn1_read_value (cert_def,
+		    asn1_internal_read_value (cert_def,
 				     "PKIX1Implicit88.id-at-organizationName",
 				     str2, &len);
 		  if (!strcmp (str, str2))
 		    {
-		      asn1_create_element (cert_def,
-					   "PKIX1Implicit88.X520OrganizationName",
-					   &value);
+		      asn1_internal_create_element (cert_def,
+						    "PKIX1Implicit88.X520OrganizationName",
+						    &value);
 		      len = sizeof (str) - 1;
-		      asn1_read_value (cert, name3, str, &len);
-		      asn1_der_decoding (&value, str, len, errorDescription);
+		      asn1_internal_read_value (cert, name3, str, &len);
+		      asn1_internal_der_decoding (&value, str, len, errorDescription);
 		      len = sizeof (str) - 1;
-		      asn1_read_value (value, "", str, &len);	/* CHOICE */
+		      asn1_internal_read_value (value, "", str, &len);	/* CHOICE */
 		      strcpy (name3, str);
 		      len = sizeof (str) - 1;
-		      asn1_read_value (value, name3, str, &len);
+		      asn1_internal_read_value (value, name3, str, &len);
 		      str[len] = 0;
 		      strcat (answer, " O=");
 		      strcat (answer, str);
-		      asn1_delete_structure (&value);
+		      asn1_internal_delete_structure (&value);
 		    }
 		  else
 		    {
 		      len = sizeof (str2) - 1;
 		      result =
-			asn1_read_value (cert_def,
+			asn1_internal_read_value (cert_def,
 					 "PKIX1Implicit88.id-at-organizationalUnitName",
 					 str2, &len);
 		      if (!strcmp (str, str2))
 			{
-			  asn1_create_element (cert_def,
-					       "PKIX1Implicit88.X520OrganizationalUnitName",
-					       &value);
+			  asn1_internal_create_element (cert_def,
+							"PKIX1Implicit88.X520OrganizationalUnitName",
+							&value);
 			  len = sizeof (str) - 1;
-			  asn1_read_value (cert, name3, str, &len);
-			  asn1_der_decoding (&value, str, len,
+			  asn1_internal_read_value (cert, name3, str, &len);
+			  asn1_internal_der_decoding (&value, str, len,
 					     errorDescription);
 			  len = sizeof (str) - 1;
-			  asn1_read_value (value, "", str, &len);	/* CHOICE */
+			  asn1_internal_read_value (value, "", str, &len);	/* CHOICE */
 			  strcpy (name3, str);
 			  len = sizeof (str) - 1;
-			  asn1_read_value (value, name3, str, &len);
+			  asn1_internal_read_value (value, name3, str, &len);
 			  str[len] = 0;
 			  strcat (answer, " OU=");
 			  strcat (answer, str);
-			  asn1_delete_structure (&value);
+			  asn1_internal_delete_structure (&value);
 			}
 		    }
 		}
@@ -222,7 +222,7 @@ create_certificate (ASN1_TYPE cert_def, unsigned char *der, int *der_len)
   max_len = *der_len;
 
   result =
-    asn1_create_element (cert_def, "PKIX1Implicit88.Certificate", &cert1);
+    asn1_internal_create_element (cert_def, "PKIX1Implicit88.Certificate", &cert1);
 
   /* Use the next 3 lines to visit the empty certificate */
   /* printf("-----------------\n");
@@ -230,234 +230,234 @@ create_certificate (ASN1_TYPE cert_def, unsigned char *der, int *der_len)
      printf("-----------------\n"); */
 
   /* version: v3(2) */
-  result = asn1_write_value (cert1, "tbsCertificate.version", "v3", 0);
+  result = asn1_internal_write_value (cert1, "tbsCertificate.version", "v3", 0);
 
   /* serialNumber: 17 */
-  result = asn1_write_value (cert1, "tbsCertificate.serialNumber", "17", 0);
+  result = asn1_internal_write_value (cert1, "tbsCertificate.serialNumber", "17", 0);
 
   /* signature: dsa-with-sha1 */
   len = sizeof (str) - 1;
   result =
-    asn1_read_value (cert_def, "PKIX1Implicit88.id-dsa-with-sha1", str, &len);
+    asn1_internal_read_value (cert_def, "PKIX1Implicit88.id-dsa-with-sha1", str, &len);
   result =
-    asn1_write_value (cert1, "tbsCertificate.signature.algorithm", str, 1);
+    asn1_internal_write_value (cert1, "tbsCertificate.signature.algorithm", str, 1);
 
-  result = asn1_write_value (cert1, "tbsCertificate.signature.parameters",
+  result = asn1_internal_write_value (cert1, "tbsCertificate.signature.parameters",
 			     NULL, 0);
 
 
   /* issuer: Country="US" Organization="gov" OrganizationUnit="nist" */
   result =
-    asn1_write_value (cert1, "tbsCertificate.issuer", "rdnSequence", 12);
+    asn1_internal_write_value (cert1, "tbsCertificate.issuer", "rdnSequence", 12);
 
   result =
-    asn1_write_value (cert1, "tbsCertificate.issuer.rdnSequence", "NEW", 1);
+    asn1_internal_write_value (cert1, "tbsCertificate.issuer.rdnSequence", "NEW", 1);
   result =
-    asn1_write_value (cert1, "tbsCertificate.issuer.rdnSequence.?LAST", "NEW",
+    asn1_internal_write_value (cert1, "tbsCertificate.issuer.rdnSequence.?LAST", "NEW",
 		      1);
   /* C */
   len = sizeof (str) - 1;
   result =
-    asn1_read_value (cert_def, "PKIX1Implicit88.id-at-countryName", str,
+    asn1_internal_read_value (cert_def, "PKIX1Implicit88.id-at-countryName", str,
 		     &len);
   result =
-    asn1_write_value (cert1,
+    asn1_internal_write_value (cert1,
 		      "tbsCertificate.issuer.rdnSequence.?LAST.?LAST.type",
 		      str, 1);
   result =
-    asn1_create_element (cert_def, "PKIX1Implicit88.X520countryName", &value);
-  result = asn1_write_value (value, "", "US", 2);
+    asn1_internal_create_element (cert_def, "PKIX1Implicit88.X520countryName", &value);
+  result = asn1_internal_write_value (value, "", "US", 2);
   *der_len = max_len;
-  result = asn1_der_coding (value, "", der, der_len, errorDescription);
-  asn1_delete_structure (&value);
+  result = asn1_internal_der_coding (value, "", der, der_len, errorDescription);
+  asn1_internal_delete_structure (&value);
   result =
-    asn1_write_value (cert1,
+    asn1_internal_write_value (cert1,
 		      "tbsCertificate.issuer.rdnSequence.?LAST.?LAST.value",
 		      der, *der_len);
 
 
   result =
-    asn1_write_value (cert1, "tbsCertificate.issuer.rdnSequence", "NEW", 1);
+    asn1_internal_write_value (cert1, "tbsCertificate.issuer.rdnSequence", "NEW", 1);
   result =
-    asn1_write_value (cert1, "tbsCertificate.issuer.rdnSequence.?LAST", "NEW",
+    asn1_internal_write_value (cert1, "tbsCertificate.issuer.rdnSequence.?LAST", "NEW",
 		      1);
   /* O */
   len = sizeof (str) - 1;
   result =
-    asn1_read_value (cert_def, "PKIX1Implicit88.id-at-organizationName", str,
+    asn1_internal_read_value (cert_def, "PKIX1Implicit88.id-at-organizationName", str,
 		     &len);
   result =
-    asn1_write_value (cert1,
+    asn1_internal_write_value (cert1,
 		      "tbsCertificate.issuer.rdnSequence.?LAST.?LAST.type",
 		      str, 1);
   result =
-    asn1_create_element (cert_def, "PKIX1Implicit88.X520OrganizationName",
-			 &value);
-  result = asn1_write_value (value, "", "printableString", 1);
-  result = asn1_write_value (value, "printableString", "gov", 3);
+    asn1_internal_create_element (cert_def, "PKIX1Implicit88.X520OrganizationName",
+				  &value);
+  result = asn1_internal_write_value (value, "", "printableString", 1);
+  result = asn1_internal_write_value (value, "printableString", "gov", 3);
   *der_len = max_len;
-  result = asn1_der_coding (value, "", der, der_len, errorDescription);
-  asn1_delete_structure (&value);
+  result = asn1_internal_der_coding (value, "", der, der_len, errorDescription);
+  asn1_internal_delete_structure (&value);
   result =
-    asn1_write_value (cert1,
+    asn1_internal_write_value (cert1,
 		      "tbsCertificate.issuer.rdnSequence.?LAST.?LAST.value",
 		      der, *der_len);
 
 
   result =
-    asn1_write_value (cert1, "tbsCertificate.issuer.rdnSequence", "NEW", 1);
+    asn1_internal_write_value (cert1, "tbsCertificate.issuer.rdnSequence", "NEW", 1);
   result =
-    asn1_write_value (cert1, "tbsCertificate.issuer.rdnSequence.?LAST", "NEW",
+    asn1_internal_write_value (cert1, "tbsCertificate.issuer.rdnSequence.?LAST", "NEW",
 		      1);
 
   /* OU */
   len = sizeof (str) - 1;
   result =
-    asn1_read_value (cert_def, "PKIX1Implicit88.id-at-organizationalUnitName",
+    asn1_internal_read_value (cert_def, "PKIX1Implicit88.id-at-organizationalUnitName",
 		     str, &len);
   result =
-    asn1_write_value (cert1,
+    asn1_internal_write_value (cert1,
 		      "tbsCertificate.issuer.rdnSequence.?LAST.?LAST.type",
 		      str, 1);
   result =
-    asn1_create_element (cert_def,
-			 "PKIX1Implicit88.X520OrganizationalUnitName",
-			 &value);
-  result = asn1_write_value (value, "", "printableString", 1);
-  result = asn1_write_value (value, "printableString", "nist", 4);
+    asn1_internal_create_element (cert_def,
+				  "PKIX1Implicit88.X520OrganizationalUnitName",
+				  &value);
+  result = asn1_internal_write_value (value, "", "printableString", 1);
+  result = asn1_internal_write_value (value, "printableString", "nist", 4);
   *der_len = max_len;
-  result = asn1_der_coding (value, "", der, der_len, errorDescription);
-  asn1_delete_structure (&value);
+  result = asn1_internal_der_coding (value, "", der, der_len, errorDescription);
+  asn1_internal_delete_structure (&value);
   result =
-    asn1_write_value (cert1,
+    asn1_internal_write_value (cert1,
 		      "tbsCertificate.issuer.rdnSequence.?LAST.?LAST.value",
 		      der, *der_len);
 
 
   /* validity */
   result =
-    asn1_write_value (cert1, "tbsCertificate.validity.notBefore", "utcTime",
+    asn1_internal_write_value (cert1, "tbsCertificate.validity.notBefore", "utcTime",
 		      1);
   result =
-    asn1_write_value (cert1, "tbsCertificate.validity.notBefore.utcTime",
+    asn1_internal_write_value (cert1, "tbsCertificate.validity.notBefore.utcTime",
 		      "970630000000Z", 1);
 
   result =
-    asn1_write_value (cert1, "tbsCertificate.validity.notAfter", "utcTime",
+    asn1_internal_write_value (cert1, "tbsCertificate.validity.notAfter", "utcTime",
 		      1);
   result =
-    asn1_write_value (cert1, "tbsCertificate.validity.notAfter.utcTime",
+    asn1_internal_write_value (cert1, "tbsCertificate.validity.notAfter.utcTime",
 		      "971231000000Z", 1);
 
 
 
   /* subject: Country="US" Organization="gov" OrganizationUnit="nist" */
   result =
-    asn1_write_value (cert1, "tbsCertificate.subject", "rdnSequence", 1);
+    asn1_internal_write_value (cert1, "tbsCertificate.subject", "rdnSequence", 1);
 
   result =
-    asn1_write_value (cert1, "tbsCertificate.subject.rdnSequence", "NEW", 1);
+    asn1_internal_write_value (cert1, "tbsCertificate.subject.rdnSequence", "NEW", 1);
   result =
-    asn1_write_value (cert1, "tbsCertificate.subject.rdnSequence.?LAST",
+    asn1_internal_write_value (cert1, "tbsCertificate.subject.rdnSequence.?LAST",
 		      "NEW", 1);
   /* C */
   len = sizeof (str) - 1;
   result =
-    asn1_read_value (cert_def, "PKIX1Implicit88.id-at-countryName", str,
+    asn1_internal_read_value (cert_def, "PKIX1Implicit88.id-at-countryName", str,
 		     &len);
   result =
-    asn1_write_value (cert1,
+    asn1_internal_write_value (cert1,
 		      "tbsCertificate.subject.rdnSequence.?LAST.?LAST.type",
 		      str, 1);
   result =
-    asn1_create_element (cert_def, "PKIX1Implicit88.X520countryName", &value);
-  result = asn1_write_value (value, "", "US", 2);
+    asn1_internal_create_element (cert_def, "PKIX1Implicit88.X520countryName", &value);
+  result = asn1_internal_write_value (value, "", "US", 2);
   *der_len = max_len;
-  result = asn1_der_coding (value, "", der, der_len, errorDescription);
-  asn1_delete_structure (&value);
+  result = asn1_internal_der_coding (value, "", der, der_len, errorDescription);
+  asn1_internal_delete_structure (&value);
   result =
-    asn1_write_value (cert1,
+    asn1_internal_write_value (cert1,
 		      "tbsCertificate.subject.rdnSequence.?LAST.?LAST.value",
 		      der, *der_len);
 
 
   result =
-    asn1_write_value (cert1, "tbsCertificate.subject.rdnSequence", "NEW", 4);
+    asn1_internal_write_value (cert1, "tbsCertificate.subject.rdnSequence", "NEW", 4);
   result =
-    asn1_write_value (cert1, "tbsCertificate.subject.rdnSequence.?LAST",
+    asn1_internal_write_value (cert1, "tbsCertificate.subject.rdnSequence.?LAST",
 		      "NEW", 4);
   /* O */
   len = sizeof (str) - 1;
   result =
-    asn1_read_value (cert_def, "PKIX1Implicit88.id-at-organizationName", str,
+    asn1_internal_read_value (cert_def, "PKIX1Implicit88.id-at-organizationName", str,
 		     &len);
   result =
-    asn1_write_value (cert1,
+    asn1_internal_write_value (cert1,
 		      "tbsCertificate.subject.rdnSequence.?LAST.?LAST.type",
 		      str, 1);
   result =
-    asn1_create_element (cert_def, "PKIX1Implicit88.X520OrganizationName",
-			 &value);
-  result = asn1_write_value (value, "", "printableString", 1);
-  result = asn1_write_value (value, "printableString", "gov", 3);
+    asn1_internal_create_element (cert_def, "PKIX1Implicit88.X520OrganizationName",
+				  &value);
+  result = asn1_internal_write_value (value, "", "printableString", 1);
+  result = asn1_internal_write_value (value, "printableString", "gov", 3);
   *der_len = max_len;
-  result = asn1_der_coding (value, "", der, der_len, errorDescription);
-  asn1_delete_structure (&value);
+  result = asn1_internal_der_coding (value, "", der, der_len, errorDescription);
+  asn1_internal_delete_structure (&value);
   result =
-    asn1_write_value (cert1,
+    asn1_internal_write_value (cert1,
 		      "tbsCertificate.subject.rdnSequence.?LAST.?LAST.value",
 		      der, *der_len);
 
 
   result =
-    asn1_write_value (cert1, "tbsCertificate.subject.rdnSequence", "NEW", 4);
+    asn1_internal_write_value (cert1, "tbsCertificate.subject.rdnSequence", "NEW", 4);
   result =
-    asn1_write_value (cert1, "tbsCertificate.subject.rdnSequence.?LAST",
+    asn1_internal_write_value (cert1, "tbsCertificate.subject.rdnSequence.?LAST",
 		      "NEW", 4);
   /* OU */
   len = sizeof (str) - 1;
   result =
-    asn1_read_value (cert_def, "PKIX1Implicit88.id-at-organizationalUnitName",
+    asn1_internal_read_value (cert_def, "PKIX1Implicit88.id-at-organizationalUnitName",
 		     str, &len);
   result =
-    asn1_write_value (cert1,
+    asn1_internal_write_value (cert1,
 		      "tbsCertificate.subject.rdnSequence.?LAST.?LAST.type",
 		      str, 1);
   result =
-    asn1_create_element (cert_def,
-			 "PKIX1Implicit88.X520OrganizationalUnitName",
-			 &value);
-  result = asn1_write_value (value, "", "printableString", 1);
-  result = asn1_write_value (value, "printableString", "nist", 4);
+    asn1_internal_create_element (cert_def,
+				  "PKIX1Implicit88.X520OrganizationalUnitName",
+				  &value);
+  result = asn1_internal_write_value (value, "", "printableString", 1);
+  result = asn1_internal_write_value (value, "printableString", "nist", 4);
   *der_len = max_len;
-  result = asn1_der_coding (value, "", der, der_len, errorDescription);
-  asn1_delete_structure (&value);
+  result = asn1_internal_der_coding (value, "", der, der_len, errorDescription);
+  asn1_internal_delete_structure (&value);
   result =
-    asn1_write_value (cert1,
+    asn1_internal_write_value (cert1,
 		      "tbsCertificate.subject.rdnSequence.?LAST.?LAST.value",
 		      der, *der_len);
 
 
   /* subjectPublicKeyInfo: dsa with parameters=Dss-Parms */
   len = sizeof (str) - 1;
-  result = asn1_read_value (cert_def, "PKIX1Implicit88.id-dsa", str, &len);
+  result = asn1_internal_read_value (cert_def, "PKIX1Implicit88.id-dsa", str, &len);
   result =
-    asn1_write_value (cert1,
+    asn1_internal_write_value (cert1,
 		      "tbsCertificate.subjectPublicKeyInfo.algorithm.algorithm",
 		      str, 1);
   result =
-    asn1_create_element (cert_def, "PKIX1Implicit88.Dss-Parms", &param);
+    asn1_internal_create_element (cert_def, "PKIX1Implicit88.Dss-Parms", &param);
   str2 = (const unsigned char *) "\xd4\x38";	/* only an example */
-  result = asn1_write_value (param, "p", str2, 128);
+  result = asn1_internal_write_value (param, "p", str2, 128);
   str2 = (const unsigned char *) "\xd4\x38";	/* only an example */
-  result = asn1_write_value (param, "q", str2, 20);
+  result = asn1_internal_write_value (param, "q", str2, 20);
   str2 = (const unsigned char *) "\xd4\x38";	/* only an example */
-  result = asn1_write_value (param, "g", str2, 128);
+  result = asn1_internal_write_value (param, "g", str2, 128);
   *der_len = max_len;
-  result = asn1_der_coding (param, "", der, der_len, errorDescription);
-  asn1_delete_structure (&param);
+  result = asn1_internal_der_coding (param, "", der, der_len, errorDescription);
+  asn1_internal_delete_structure (&param);
   result =
-    asn1_write_value (cert1,
+    asn1_internal_write_value (cert1,
 		      "tbsCertificate.subjectPublicKeyInfo.algorithm.parameters",
 		      der, *der_len);
 
@@ -465,69 +465,69 @@ create_certificate (ASN1_TYPE cert_def, unsigned char *der, int *der_len)
   /* subjectPublicKey */
   str2 = (const unsigned char *) "\x02\x81";	/* only an example */
   result =
-    asn1_write_value (cert1,
+    asn1_internal_write_value (cert1,
 		      "tbsCertificate.subjectPublicKeyInfo.subjectPublicKey",
 		      str2, 1048);
 
-  result = asn1_write_value (cert1, "tbsCertificate.issuerUniqueID", NULL, 0);	/* NO OPTION */
-  result = asn1_write_value (cert1, "tbsCertificate.subjectUniqueID", NULL, 0);	/* NO OPTION */
+  result = asn1_internal_write_value (cert1, "tbsCertificate.issuerUniqueID", NULL, 0);	/* NO OPTION */
+  result = asn1_internal_write_value (cert1, "tbsCertificate.subjectUniqueID", NULL, 0);	/* NO OPTION */
 
   /* extensions */
-  result = asn1_write_value (cert1, "tbsCertificate.extensions", "NEW", 1);
+  result = asn1_internal_write_value (cert1, "tbsCertificate.extensions", "NEW", 1);
   len = sizeof (str) - 1;
   result =
-    asn1_read_value (cert_def, "PKIX1Implicit88.id-ce-basicConstraints", str,
+    asn1_internal_read_value (cert_def, "PKIX1Implicit88.id-ce-basicConstraints", str,
 		     &len);
-  result = asn1_write_value (cert1, "tbsCertificate.extensions.?LAST.extnID", str, 1);	/*   basicConstraints */
+  result = asn1_internal_write_value (cert1, "tbsCertificate.extensions.?LAST.extnID", str, 1);	/*   basicConstraints */
   result =
-    asn1_write_value (cert1, "tbsCertificate.extensions.?LAST.critical",
+    asn1_internal_write_value (cert1, "tbsCertificate.extensions.?LAST.critical",
 		      "TRUE", 1);
   result =
-    asn1_create_element (cert_def, "PKIX1Implicit88.BasicConstraints",
-			 &constr);
-  result = asn1_write_value (constr, "cA", "TRUE", 1);
-  result = asn1_write_value (constr, "pathLenConstraint", NULL, 0);
+    asn1_internal_create_element (cert_def, "PKIX1Implicit88.BasicConstraints",
+				  &constr);
+  result = asn1_internal_write_value (constr, "cA", "TRUE", 1);
+  result = asn1_internal_write_value (constr, "pathLenConstraint", NULL, 0);
   *der_len = max_len;
-  result = asn1_der_coding (constr, "", der, der_len, errorDescription);
-  result = asn1_delete_structure (&constr);
+  result = asn1_internal_der_coding (constr, "", der, der_len, errorDescription);
+  result = asn1_internal_delete_structure (&constr);
   result =
-    asn1_write_value (cert1, "tbsCertificate.extensions.?LAST.extnValue", der,
+    asn1_internal_write_value (cert1, "tbsCertificate.extensions.?LAST.extnValue", der,
 		      *der_len);
 
 
-  result = asn1_write_value (cert1, "tbsCertificate.extensions", "NEW", 1);
+  result = asn1_internal_write_value (cert1, "tbsCertificate.extensions", "NEW", 1);
   len = sizeof (str) - 1;
   result =
-    asn1_read_value (cert_def, "PKIX1Implicit88.id-ce-subjectKeyIdentifier",
+    asn1_internal_read_value (cert_def, "PKIX1Implicit88.id-ce-subjectKeyIdentifier",
 		     str, &len);
-  result = asn1_write_value (cert1, "tbsCertificate.extensions.?LAST.extnID", str, 1);	/* subjectKeyIdentifier */
+  result = asn1_internal_write_value (cert1, "tbsCertificate.extensions.?LAST.extnID", str, 1);	/* subjectKeyIdentifier */
   result =
-    asn1_write_value (cert1, "tbsCertificate.extensions.?LAST.critical",
+    asn1_internal_write_value (cert1, "tbsCertificate.extensions.?LAST.critical",
 		      "FALSE", 1);
   str2 = (const unsigned char *) "\x04\x14\xe7\x26\xc5";	/* only an example */
   result =
-    asn1_write_value (cert1, "tbsCertificate.extensions.?LAST.extnValue",
+    asn1_internal_write_value (cert1, "tbsCertificate.extensions.?LAST.extnValue",
 		      str2, 22);
 
 
   /* signatureAlgorithm: dsa-with-sha  */
   len = sizeof (str) - 1;
   result =
-    asn1_read_value (cert_def, "PKIX1Implicit88.id-dsa-with-sha1", str, &len);
-  result = asn1_write_value (cert1, "signatureAlgorithm.algorithm", str, 1);
-  result = asn1_write_value (cert1, "signatureAlgorithm.parameters", NULL, 0);	/* NO OPTION */
+    asn1_internal_read_value (cert_def, "PKIX1Implicit88.id-dsa-with-sha1", str, &len);
+  result = asn1_internal_write_value (cert1, "signatureAlgorithm.algorithm", str, 1);
+  result = asn1_internal_write_value (cert1, "signatureAlgorithm.parameters", NULL, 0);	/* NO OPTION */
 
 
   /* signature */
   *der_len = max_len;
   result =
-    asn1_der_coding (cert1, "tbsCertificate", der, der_len, errorDescription);
+    asn1_internal_der_coding (cert1, "tbsCertificate", der, der_len, errorDescription);
   if (result != ASN1_SUCCESS)
     {
       printf ("\n'tbsCertificate' encoding creation: ERROR\n");
     }
   /* add the lines for the signature on der[0]..der[der_len-1]: result in str2 */
-  result = asn1_write_value (cert1, "signature", str2, 368);	/* dsa-with-sha */
+  result = asn1_internal_write_value (cert1, "signature", str2, 368);	/* dsa-with-sha */
 
 
   /* Use the next 3 lines to visit the certificate */
@@ -536,7 +536,7 @@ create_certificate (ASN1_TYPE cert_def, unsigned char *der, int *der_len)
      printf("-----------------\n"); */
 
   *der_len = max_len;
-  result = asn1_der_coding (cert1, "", der, der_len, errorDescription);
+  result = asn1_internal_der_coding (cert1, "", der, der_len, errorDescription);
   if (result != ASN1_SUCCESS)
     {
       printf ("\n'certificate' encoding creation: ERROR\n");
@@ -551,7 +551,7 @@ create_certificate (ASN1_TYPE cert_def, unsigned char *der, int *der_len)
   printf ("\n-----------------\n");
 
   /* Clear the "certificate1" structure */
-  asn1_delete_structure (&cert1);
+  asn1_internal_delete_structure (&cert1);
 }
 
 
@@ -573,9 +573,9 @@ get_certificate (ASN1_TYPE cert_def, unsigned char *der, int der_len)
   ASN1_TYPE cert2 = ASN1_TYPE_EMPTY;
   char errorDescription[ASN1_MAX_ERROR_DESCRIPTION_SIZE];
 
-  asn1_create_element (cert_def, "PKIX1Implicit88.Certificate", &cert2);
+  asn1_internal_create_element (cert_def, "PKIX1Implicit88.Certificate", &cert2);
 
-  result = asn1_der_decoding (&cert2, der, der_len, errorDescription);
+  result = asn1_internal_der_decoding (&cert2, der, der_len, errorDescription);
 
   if (result != ASN1_SUCCESS)
     {
@@ -594,22 +594,22 @@ get_certificate (ASN1_TYPE cert_def, unsigned char *der, int der_len)
 
   /* Verify sign */
   len = sizeof (str) - 1;
-  result = asn1_read_value (cert2, "signatureAlgorithm.algorithm", str, &len);
+  result = asn1_internal_read_value (cert2, "signatureAlgorithm.algorithm", str, &len);
 
   len = sizeof (str2) - 1;
   result =
-    asn1_read_value (cert_def, "PKIX1Implicit88.id-dsa-with-sha1", str2,
+    asn1_internal_read_value (cert_def, "PKIX1Implicit88.id-dsa-with-sha1", str2,
 		     &len);
   if (!strcmp ((char *) str, (char *) str2))
     {				/* dsa-with-sha */
 
-      result = asn1_der_decoding_startEnd (cert2, der, der_len,
+      result = asn1_internal_der_decoding_startEnd (cert2, der, der_len,
 					   "tbsCertificate", &start, &end);
 
       /* add the lines to calculate the sha on der[start]..der[end] */
 
       len = sizeof (str) - 1;
-      result = asn1_read_value (cert2, "signature", str, &len);
+      result = asn1_internal_read_value (cert2, "signature", str, &len);
 
       /* compare the previous value to signature ( with issuer public key) */
     }
@@ -621,7 +621,7 @@ get_certificate (ASN1_TYPE cert_def, unsigned char *der, int der_len)
 
 
   /* Clear the "certificate2" structure */
-  asn1_delete_structure (&cert2);
+  asn1_internal_delete_structure (&cert2);
 }
 
 extern const ASN1_ARRAY_TYPE pkix_asn1_tab[];
@@ -643,14 +643,14 @@ main (int argc, char *argv[])
 
   if (1)
     result =
-      asn1_array2tree (pkix_asn1_tab, &PKIX1Implicit88, errorDescription);
+      asn1_internal_array2tree (pkix_asn1_tab, &PKIX1Implicit88, errorDescription);
   else
     result =
-      asn1_parser2tree ("pkix.asn", &PKIX1Implicit88, errorDescription);
+      asn1_internal_parser2tree ("pkix.asn", &PKIX1Implicit88, errorDescription);
 
   if (result != ASN1_SUCCESS)
     {
-      asn1_perror (result);
+      asn1_internal_perror (result);
       printf ("%s", errorDescription);
       exit (1);
     }
@@ -667,7 +667,7 @@ main (int argc, char *argv[])
   get_certificate (PKIX1Implicit88, der, der_len);
 
   /* Clear the "PKIX1Implicit88" structures */
-  asn1_delete_structure (&PKIX1Implicit88);
+  asn1_internal_delete_structure (&PKIX1Implicit88);
 
   return 0;
 }
